﻿using DumpTruck;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Net.NetworkInformation;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DumpTruck.Entities;


namespace DumpTruck.DrawningObjects
{
    public class DrawningDumpTruck : DrawningCar
    {


        public DrawningDumpTruck(int speed, double weight, Color bodyColor, Color additionalColor, bool bodyKit, bool tent, int width, int height): base(speed, weight, bodyColor, width, height, 110, 60)
        {
            if (EntityCar != null)
            {
                EntityCar = new EntityDumpTruck(speed, weight, bodyColor,additionalColor, bodyKit, tent);
            }
        }
        
        
        public override void DrawTransport(Graphics g)
        {
            if (EntityCar is not EntityDumpTruck dumpTruck)
            {
                return;
            }

            Pen pen = new Pen(Color.Black);
            Brush addBrush = new SolidBrush(dumpTruck.AdditionalColor);
            Brush brush = new SolidBrush(dumpTruck.BodyColor);

            base.DrawTransport(g);
            if (dumpTruck.Tent)
            {
                Point[] points = new Point[3];
                points[0].X = _startPosX; points[0].Y = _startPosY + 35;
                points[1].X = _startPosX + 85; points[1].Y = _startPosY;
                points[2].X = _startPosX + 85; points[2].Y = _startPosY + 35;
                g.FillPolygon(addBrush, points);
            }

            if (dumpTruck.BodyKit)
            {
                Point[] points = new Point[4];
                points[0].X = _startPosX; points[0].Y = _startPosY + 35;
                points[1].X = _startPosX; points[1].Y = _startPosY;
                points[2].X = _startPosX + 85; points[2].Y = _startPosY;
                points[3].X = _startPosX + 85; points[3].Y = _startPosY + 35;
                g.FillPolygon(addBrush, points);
            }

            if (dumpTruck.BodyKit && dumpTruck.Tent)
            {
                int x = _startPosX;
                int y = _startPosY - 8;
                g.FillRectangle(brush, _startPosX, _startPosY, 95, 3);
                for (int i = 0; i < 6; i++)
                {
                    Rectangle smallRect = new Rectangle(x, y, 15, 15);
                    g.FillPie(brush, smallRect, 0, 180);
                    x += 15;
                }
            }
        }
    }
}


